
Ruby - Bug #16522

Ruby 2.7 logs deprecation warning when Warning[:deprecated] is set to false.  

01/22/2020 10:31 AM - snehasomwanshi@gmail.com (Sneha Somwanshi)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: 2.7 Backport: 2.5: DONTNEED, 2.6: DONTNEED, 2.7:

DONTNEED

Description

Hi

While upgrading our monolithic app to ruby 2.7, we realised that ruby 2.7 is not suppressing all deprecation warnings.

Here is the test case:

~/dev/freeagent (ruby_2_7_0 *%) $ ruby -W:no-deprecated -e 'require "json"; JSON::Ext::Parser.new(

"hello", {})'

-e:1: warning: Using the last argument as keyword parameters is deprecated

 The warning is originating from https://github.com/ruby/ruby/blob/647ee6f091eafcce70ffb75ddf7e121e192ab217/class.c#L2054 and

setting  Warning[:deprecated] = false or RUBYOPT=-W:no-deprecated -W:no-experimental does not suppress this warning.

History

#1 - 01/23/2020 12:38 PM - snehasomwanshi@gmail.com (Sneha Somwanshi)

- Description updated

#2 - 01/23/2020 05:17 PM - jeremyevans0 (Jeremy Evans)

This no longer applies to the master branch, as the warnings have been removed.

Fixing this in 2.7 could be challenging, as the function to deduplicate warnings is static in vm_args.c.  That function would have to be made non-static

at least.  The function also requires access to ec and iseq, and while I think ec is possible to get access to, I'm not sure about iseq.

You can work around the issue using the warning gem and using Warning.dedup.

#3 - 05/29/2020 04:57 PM - jeremyevans0 (Jeremy Evans)

- File scan-args-deprecated-warn-16522.patch added

- Status changed from Open to Closed

- Backport changed from 2.5: UNKNOWN, 2.6: UNKNOWN, 2.7: UNKNOWN to 2.5: DONTNEED, 2.6: DONTNEED, 2.7: REQUIRED

I took another look at this and I think we can silence the deprecation warnings with -W:no-deprecated even if we can't deduplicate the warnings. 

Attached is a patch that implements this.  I'm not sure if the approach in ruby.h is acceptable (rb_scan_args has both an unoptimized version in

class.c and an optimized version in ruby.h).

#4 - 07/26/2020 09:11 AM - nagachika (Tomoyuki Chikanaga)

We are discussing on the deprecated warning category feature in 2.7.2 on #17000 too.

As these are keyword arguments warnings, these will be suppressed by default in 2.7.2 anyway.

#5 - 12/31/2020 06:36 AM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.5: DONTNEED, 2.6: DONTNEED, 2.7: REQUIRED to 2.5: DONTNEED, 2.6: DONTNEED, 2.7: DONTNEED

Files

scan-args-deprecated-warn-16522.patch 6.79 KB 05/29/2020 jeremyevans0 (Jeremy Evans)
